Index: trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/Resources.Designer.cs
===================================================================
--- trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/Resources.Designer.cs	(revision 4176)
+++ trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/Resources.Designer.cs	(revision 4181)
@@ -61,8 +61,36 @@
         }
         
-        internal static System.Drawing.Icon HeuristicLabIcon {
+        internal static System.Drawing.Bitmap HL3_Logo {
             get {
-                object obj = ResourceManager.GetObject("HeuristicLabIcon", resourceCulture);
-                return ((System.Drawing.Icon)(obj));
+                object obj = ResourceManager.GetObject("HL3_Logo", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        internal static System.Drawing.Bitmap VS2008ImageLibrary_Actions_Delete {
+            get {
+                object obj = ResourceManager.GetObject("VS2008ImageLibrary_Actions_Delete", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        internal static System.Drawing.Bitmap VS2008ImageLibrary_CommonElements_Actions_Add {
+            get {
+                object obj = ResourceManager.GetObject("VS2008ImageLibrary_CommonElements_Actions_Add", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        internal static System.Drawing.Bitmap VS2008ImageLibrary_CommonElements_Objects_Arrow_Down {
+            get {
+                object obj = ResourceManager.GetObject("VS2008ImageLibrary_CommonElements_Objects_Arrow_Down", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        internal static System.Drawing.Bitmap VS2008ImageLibrary_CommonElements_Objects_Arrow_Up {
+            get {
+                object obj = ResourceManager.GetObject("VS2008ImageLibrary_CommonElements_Objects_Arrow_Up", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
             }
         }
Index: trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/Resources.resx
===================================================================
--- trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/Resources.resx	(revision 4176)
+++ trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/Resources.resx	(revision 4181)
@@ -113,12 +113,24 @@
   </resheader>
   <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
   <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
-  <assembly alias="System.Windows.Forms" name="System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
-  <data name="HeuristicLabIcon" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>..\HeuristicLabIcon.ico;System.Drawing.Icon, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  <assembly alias="System.Windows.Forms" name="System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
+  <data name="HL3_Logo" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\HL3_Logo.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="VS2008ImageLibrary_Actions_Delete" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\VS2008ImageLibrary_Actions_Delete.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="VS2008ImageLibrary_CommonElements_Actions_Add" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\VS2008ImageLibrary_CommonElements_Actions_Add.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="VS2008ImageLibrary_CommonElements_Objects_Arrow_Down" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Down.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="VS2008ImageLibrary_CommonElements_Objects_Arrow_Up" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Up.png;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
 </root>